/*************************************************************************
* ļ:	aga10.c	
* :	ٻC*
*       ʹûDetailThermĶ
*       º:
*       AGA10_Init(), AGA10_UnInit(), SOS(), Crit(), Cperf(), CRi()
* 汾:	ver 1.7	2002.11.17
* :	W.B. Peterson
* ޶:
* Ȩ (c) 2002  ȻЭ

**************************************************************************/

#include "NGCal.h" 
#include "Therm.h" 
#include "Detail.h"

// ļĶָ룺һThermһDetail
static Therm *ptTherm;
static Detail *ptDetail;

/**************************************************************************
*		:	AGA10_Init()
*		:	void
*	ֵ	:	int
*		:	ʼ⣻
*	޶	:	
**************************************************************************/

 int NGCal_Init(void)
{
	ptDetail = (Detail *)malloc(sizeof(Detail));
    // ڼܶȵĶ
    if (NULL == ptDetail )
    {
        return MEMORY_ALLOCATION_ERROR;
    }

    // ڼѧʵĶ
		 ptTherm = (Therm *)malloc(sizeof(Therm));
    if (NULL == ptTherm )
    {
        return MEMORY_ALLOCATION_ERROR;
    }

    return AGA10_INITIALIZED;
}

/**************************************************************************
*		:	AGA10_UnInit()
*		:	void
*	ֵ	:	int
*		:	ʼ⣻ɾ
*	޶	:	
**************************************************************************/

 int NGCal_UnInit(void)
{
    // ɾڣ
    if (ptDetail) free( ptDetail);
    if (ptTherm) free (ptTherm);
    return 0;
}

/**************************************************************************
*		:	SOS()
*		:	ָⲿAGA10ݽṹָ
*	ֵ	:	double
*		:	ٺ
*	޶	:	
**************************************************************************/

 double SOS(AGA10STRUCT *ptAGA10)
{
    // ǷҪʱʼ
    if (NULL == ptDetail || NULL == ptTherm)
    {
        NGCal_UnInit();
        NGCal_Init();
    }

    // úܶȺѧ
    ptTherm->Run(ptTherm,ptAGA10, ptDetail);

    // ټ㲻C*ʼΪ
    ptAGA10->dCstar = 0.0;

    // ٸ
    return ptAGA10->dSOS;
}

/**************************************************************************
*		:	Crit()
*		:	ָⲿAGA10ݽṹָ롢DetailThermԼһ˫ȸܵеٶȣ
*	ֵ	:	double
*		:	C*
*	޶	:	
**************************************************************************/

 double Crit(AGA10STRUCT *ptAGA10, double dPlenumVelocity)
{
    // ֲ
    double DH, DDH, S, H;
    double tolerance = 1.0;
    double R, P, T, Z;
    int i;

    // ǷδԳʼ
    if (NULL == ptDetail || NULL == ptTherm)
    {
        NGCal_UnInit();
        if (AGA10_INITIALIZED != NGCal_Init())
        {
            ptAGA10->lStatus = MEMORY_ALLOCATION_ERROR;
            return 0.0;
        }
    }

    // ȼܶȺѧ
    ptTherm->Run(ptTherm,ptAGA10, ptDetail);

    // DHǴӹܵʱ䣻ǵĳʼ²ֵ
    DH = (ptAGA10->dSOS * ptAGA10->dSOS - dPlenumVelocity * dPlenumVelocity) / 2.0;

    // Ǹıݽṹ֮ǰܵ
    S = ptAGA10->dS;
    H = ptAGA10->dH;
    R = ptAGA10->dRhof;
    P = ptAGA10->dPf;
    Z = ptAGA10->dZf;
    T = ptAGA10->dTf;

    // DHʼΪݲֵ
    DDH = 10.0;

    // ͨظѹ¶Ⱥ٣
    // ڸܵصṩ㶨ʡ
    // ѭִг100δֹ
    for (i = 1; i < MAX_NUM_OF_ITERATIONS; i++)
    {
        // HSPT
        ptTherm->HS_Mode(ptTherm,ptAGA10, ptDetail, H - DH, S, true);

        // µѧʣSOS
        ptTherm->Run(ptTherm,ptAGA10, ptDetail);

        // DHݲ
        DDH = DH;

        // ¼DH
        DH = (ptAGA10->dSOS * ptAGA10->dSOS - dPlenumVelocity * dPlenumVelocity) / 2.0;

        // ﵽݲѭ
        if (fabs(DDH - DH) < tolerance) break;
    }

    // C*ʵٽҪCperfCRi
    ptAGA10->dCstar = (ptAGA10->dRhof * ptAGA10->dSOS) / sqrt(R * P * Z);

    // ָԭʼܵѹ¶
    ptAGA10->dPf = P;
    ptAGA10->dTf = T;

    // ԻָΪܵ
    ptTherm->Run(ptTherm,ptAGA10, ptDetail);

    // ٽ
    return ptAGA10->dCstar;
}

/**************************************************************************
*		:	Cperf()
*		:	ָⲿAGA10ݽṹָ
*	ֵ	:	double
*		:	ٽ
*	޶	:	
**************************************************************************/

double Cperf(AGA10STRUCT *ptAGA10)
{
    double k, root, exponent;
    k = ptAGA10->dKappa;
    root = 2.0 / (k + 1.0);
    exponent = (k + 1.0) / (k - 1.0);

    // ٽC*i
    return(sqrt(k * pow(root, exponent)));
}

/**************************************************************************
*		:	CRi()
*		:	ָⲿAGA10ݽṹָ
*	ֵ	:	double
*		:	ʵٽCRi
*	޶	:	
**************************************************************************/

double CRi(AGA10STRUCT *ptAGA10)
{
    return (Cperf(ptAGA10) / sqrt(ptAGA10->dZf));
}

