/*************************************************************************
* ļ:	aga10.h
* :	aga10.cĺԭͺͶ
* 汾:	ver 1.7	2002.11.17
* :	W.B. Peterson
* ޶:
* Ȩ (c) 2002  ȻЭ
**************************************************************************/

#ifndef _AGA10_H 
#define _AGA10_H

 

/* ļ */ 
#include <stdio.h>
#include <stdlib.h>
 
#include <math.h>

/* ״̬ */        
#define NORMAL              9000
#define AGA10_INITIALIZED   9001
#define MEMORY_ALLOCATION_ERROR      9002
#define GENERAL_CALCULATION_FAILURE  9003
#define MAX_NUM_OF_ITERATIONS_EXCEEDED 9004
#define NEGATIVE_DENSITY_DERIVATIVE 9005
#define MAX_DENSITY_IN_BRAKET_EXCEEDED 9006

/*  */        
#define NUMBEROFCOMPONENTS 21    

/* еԴ */
#define MAX_NUM_OF_ITERATIONS 100

/* Ĭݲ */                
#define P_CHG_TOL 0.001 /* 0.001 Pa */            
#define T_CHG_TOL 0.001 /* 0.001  */        

/* PT */                
#define P_MAX    1.379e8  /* ѹ(Pa) ~= 20,000 psi */
#define P_MIN    0.0      /* Сѹ = 0 */    
#define T_MAX    473.15   /* ¶(K) ~= 392 F */
#define T_MIN    143.0    /* ¶(K) ~= -200 F */

/* ͨ峣 */    
#define RGASKJ  8.314510e-3 /* λ: kJ mol^-1 K^-1 */    
#define RGAS    8.314510    /* λ: J mol^-1 K^-1 */    

/* ʹõҪݽṹ */    
typedef struct tagAGA10STRUCT                    
{    
    long lStatus;           /* ״̬ */    
    int bForceUpdate;       /* ִź */
    double adMixture[NUMBEROFCOMPONENTS]; /* Ħ */
	  int dCbtj;              /* α   0  101.325MPa 20棻1:101325MPa15棻2:101325MPa0 */   
    double dPb;             /* ͬ׼ѹ(Pa) */
    double dTb;             /* ͬ׼¶(K) */
    double dPf;             /* ѹ(Pa) */    
    double dTf;             /* ¶(K) */    
    
    /* AGA 8 DetailĻ */        
    double dMrx;            /* Ħ */    
    double dZb;             /* ͬ׼µѹϵ */
    double dZf;             /* µѹϵ */
    double dFpv;            /* ѹϵ */    
    double dDb;             /* ͬ׼µĦܶ(moles/dm3) */
    double dDf;             /* µĦܶ(moles/dm3) */
    double dRhob;           /* ͬ׼µܶ(kg/m3) */
    double dRhof;           /* µܶ(kg/m3) */
    double dRD_Ideal;       /* ܶ */
    double dRD_Real;        /* ʵܶ */
    
    /*  */                    
    double dHo;             /*  */
    double dH;              /* ʵ(J/kg) */
    double dS;              /* ʵ(J/kg-mol.K) */
    double dCpi;            /* 嶨ѹ(J/kg-mol.K) */
    double dCp;             /* ʵ嶨ѹ(J/kg-mol.K) */
    double dCv;             /* ʵ嶨(J/kg-mol.K) */
    double dk;              /* ȱ */    
    double dKappa;          /* ָϣĸkappaʾ */
    double dSOS;            /* (m/s) */    
    double dCstar;          /* ٽϵC* */    
		
		/*11062 λ͵λ*/
		
		double dHhvMol;         /*λĦ*/
		double dLhvMol;         /*λĦ*/
		
		
} AGA10STRUCT;

/* ڸֵö */
enum gascomp {
    XiC1=0, XiN2, XiCO2, XiC2, XiC3,
    XiH2O, XiH2S, XiH2, XiCO, XiO2, 
    XiIC4, XiNC4, XiIC5, XiNC5, XiNC6, 
    XiNC7, XiNC8, XiNC9, XiNC10, XiHe, XiAr 
};

/* ԭ */

/* ʼԭ */
 int AGA10_Init(void);   /* ʼ */
 int AGA10_UnInit(void); /* ʼ */

/* VOSĺԭ */ 
 double SOS(AGA10STRUCT *);

/* C*ĺԭ */ 
 double Crit(AGA10STRUCT *, double);

#endif
