/*************************************************************************
* ļ: therm.h
* : Thermͷļ
*       ʵμtherm.cppļ
* 汾: ver 1.7 2002.11.17
* : W.B. Peterson
* ޶:
* Ȩ: (c) 2002 ȻЭ
**************************************************************************/

#ifndef _THERM_H 
#define _THERM_H

#include "NGCal.h" 
#include "Detail.h"

// Therm
typedef struct Therm {
    // Ա
    double dT;      // ǰ¶ȣλ(K)
    double dP;      // ǰѹλ˹(Pa)
    double dD;      // Ħܶȣλmol/dm3
    double dRho;    // ܶȣλkg/m3
    
    double dPdD;    // PDƫ
    
    double dPdT;    // PTƫ
    double dSi;     // أλkJ/kg.K
    double dTold;   // ֮ǰʹõ¶
    
    double dMrxold; // ֮ǰʹõĻĦ
    
    // ָ
    double (*CpiMolar)(struct Therm*, AGA10STRUCT*);
    void (*Run)(struct Therm*, AGA10STRUCT*, Detail*);
    double (*Ho)(struct Therm*, AGA10STRUCT*);
    double (*So)(struct Therm*, AGA10STRUCT*);
    void (*CprCvrHS)(struct Therm*, AGA10STRUCT*, Detail*);
    double (*H)(struct Therm*, AGA10STRUCT*, Detail*);
    double (*S)(struct Therm*, AGA10STRUCT*, Detail*);
    void (*HS_Mode)(struct Therm*, AGA10STRUCT*, Detail*, double, double, int);
} Therm;

// ThermĹ캯
Therm* Therm_construct(void);
void Therm_destruct(Therm* obj);

// Thermʹõ

// ʹ extern 
extern int GK_points;
extern double GK_root[5];
extern double GK_weight[5];
extern double ThermConstants[21][11];

// Ȼѧ·ﵽת: 1 cal(IT) = 4.1840 J
extern double CalTH ;


// ϵö
enum CoefficientList { 
    coefA = 0, 
    coefB, 
    coefC, 
    coefD, 
    coefE, 
    coefF, 
    coefG, 
    coefH, 
    coefI, 
    coefJ, 
    coefK 
};


#endif

