/* Ӳͷļ */
#include "board.h" 

/* RT-Threadͷļ */
#include <rthw.h>
#include <rtthread.h>


#if defined(RT_USING_USER_MAIN) && defined(RT_USING_HEAP)
#define RT_HEAP_SIZE 1024
/* ڲSRAMһ־̬ڴΪrttĶѿռ䣬Ϊ4KB */
static uint32_t rt_heap[RT_HEAP_SIZE];
RT_WEAK void *rt_heap_begin_get(void)
{
    return rt_heap;
}

RT_WEAK void *rt_heap_end_get(void)
{
    return rt_heap + RT_HEAP_SIZE;
}
#endif

/**
  * @brief  Ӳʼ
  * @param  
  * @retval 
  *
  * @attention
  * RTTѿصĳʼͳһŵboard.cļʵ֣
  * ȻЩͳһŵmain.cļҲǿԵġ
  */
void rt_hw_board_init()
{
	/* ϵͳʱӳʼ480MHz */
	SystemClock_Config();
	
    /* ʼSysTick */
  HAL_SYSTICK_Config( HAL_RCC_GetSysClockFreq() / RT_TICK_PER_SECOND );	
    
	/* ӲBSPʼͳͳLEDڣLCD */
    
	/* LED ˿ڳʼ */
	LED_GPIO_Config();	
	
	/* usart ˿ڳʼ */
  DEBUG_USART_Config();

  /* KEY ˿ڳʼ */
  Key_GPIO_Config();
	
/* ʼ (use INIT_BOARD_EXPORT()) */
#ifdef RT_USING_COMPONENTS_INIT
    rt_components_board_init();
#endif
    
#if defined(RT_USING_CONSOLE) && defined(RT_USING_DEVICE)
	rt_console_set_device(RT_CONSOLE_DEVICE_NAME);
#endif
    
#if defined(RT_USING_USER_MAIN) && defined(RT_USING_HEAP)
    rt_system_heap_init(rt_heap_begin_get(), rt_heap_end_get());
#endif
}

/**
  * @brief  SysTickжϷ
  * @param  
  * @retval 
  *
  * @attention
  * SysTickжϷڹ̼ļstm32f10x_it.cҲˣ
  * board.cֶһΣôʱظĴ󣬽
  * ǿ԰stm32f10x_it.cеעͻɾɡ
  */
void SysTick_Handler(void)
{
    /* ж */
    rt_interrupt_enter();

    /* ʱ */
    rt_tick_increase();

    /* 뿪ж */
    rt_interrupt_leave();
}



/**
  * @brief  ӳ䴮DEBUG_USARTxrt_kprintf()
  *   NoteDEBUG_USARTxbsp_usart.hжĺ꣬Ĭʹô1
  * @param  strҪڵַ
  * @retval 
  *
  * @attention
  * 
  */
void rt_hw_console_output(const char *str)
{	
	/* ٽ */
    rt_enter_critical();

	/* ֱַ */
    while (*str!='\0')
	{
		/*  */
        if (*str=='\n')
		{
			//HAL_UART_Transmit( &UartHandle,(uint8_t *)'\r',1,1000);
		}
			HAL_UART_Transmit( &UartHandle,(uint8_t *)(str++),1,1000);
	}	

	/* ˳ٽ */
    rt_exit_critical();
}



/**
  * @brief  System Clock 
  *         system Clock : 
	*            System Clock source  = PLL (HSE)
	*            SYSCLK(Hz)           = 480000000 (CPU Clock)
	*            HCLK(Hz)             = 240000000 (AXI and AHBs Clock)
	*            AHB Prescaler        = 2
	*            D1 APB3 Prescaler    = 2 (APB3 Clock  120MHz)
	*            D2 APB1 Prescaler    = 2 (APB1 Clock  120MHz)
	*            D2 APB2 Prescaler    = 2 (APB2 Clock  120MHz)
	*            D3 APB4 Prescaler    = 2 (APB4 Clock  120MHz)
	*            HSE Frequency(Hz)    = 25000000
	*            PLL_M                = 5
	*            PLL_N                = 192
	*            PLL_P                = 2
	*            PLL_Q                = 4
	*            PLL_R                = 2
	*            VDD(V)               = 3.3
	*            Flash Latency(WS)    = 4
  * @param  None
  * @retval None
  */
static void SystemClock_Config(void)
{
  RCC_ClkInitTypeDef RCC_ClkInitStruct;
  RCC_OscInitTypeDef RCC_OscInitStruct;
  HAL_StatusTypeDef ret = HAL_OK;
  
  /*ʹܹø */
  MODIFY_REG(PWR->CR3, PWR_CR3_SCUEN, 0);

  /* ʱƵʵϵͳƵʱѹڿŻģ
		 ϵͳƵʵĵѹֵĸ¿ԲοƷֲᡣ  */
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

  while(!__HAL_PWR_GET_FLAG(PWR_FLAG_VOSRDY)) {}
 
  /* HSEʹHSEΪԴPLL */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSIState = RCC_HSI_OFF;
  RCC_OscInitStruct.CSIState = RCC_CSI_OFF;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;

  RCC_OscInitStruct.PLL.PLLM = 5;
  RCC_OscInitStruct.PLL.PLLN = 192;
  RCC_OscInitStruct.PLL.PLLP = 2;
  RCC_OscInitStruct.PLL.PLLR = 2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
 
  RCC_OscInitStruct.PLL.PLLVCOSEL = RCC_PLL1VCOWIDE;
  RCC_OscInitStruct.PLL.PLLRGE = RCC_PLL1VCIRANGE_2;
  ret = HAL_RCC_OscConfig(&RCC_OscInitStruct);
  if(ret != HAL_OK)
  {

    while(1) { ; }
  }
  
	/* ѡPLLΪϵͳʱԴʱӷƵ */
  RCC_ClkInitStruct.ClockType = (RCC_CLOCKTYPE_SYSCLK  | \
																 RCC_CLOCKTYPE_HCLK    | \
																 RCC_CLOCKTYPE_D1PCLK1 | \
																 RCC_CLOCKTYPE_PCLK1   | \
                                 RCC_CLOCKTYPE_PCLK2   | \
																 RCC_CLOCKTYPE_D3PCLK1);
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.SYSCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB3CLKDivider = RCC_APB3_DIV2;  
  RCC_ClkInitStruct.APB1CLKDivider = RCC_APB1_DIV2; 
  RCC_ClkInitStruct.APB2CLKDivider = RCC_APB2_DIV2; 
  RCC_ClkInitStruct.APB4CLKDivider = RCC_APB4_DIV2; 
  ret = HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_4);
  if(ret != HAL_OK)
  {
    while(1) { ; }
  }
}

/****************************END OF FILE***************************/
