/**
  ******************************************************************
  * @file    core_delay.c
  * @author  fire
  * @version V1.0
  * @date    2018-xx-xx
  * @brief   ʹں˼Ĵȷʱ
  ******************************************************************
  * @attention
  *
  * ʵƽ̨:Ұ STM32H750   
  * ̳    :http://www.firebbs.cn
  * Ա    :https://fire-stm32.taobao.com
  *
  ******************************************************************
  */
  
#include "./delay/core_delay.h"   


/*
**********************************************************************
*         ʱؼĴ
**********************************************************************
*/
/*
 Cortex-MһDWT(Data Watchpoint and Trace)
 һ32λļĴCYCCNTһϵļ
 ¼ںʱеĸܼ¼ʱΪ
 8.94s=232η/480000000
 (ںƵΪ480MںһεʱΪ1/480M=2.08ns)
 CYCCNT֮󣬻0¿ʼϼ
 ʹCYCCNTĲ裺
 1ʹDWT裬ں˵ԼĴDEMCRλ24ƣд1ʹ
 2ʹCYCCNTĴ֮ǰ0
 3ʹCYCCNTĴDWT_CTRL(Ϻ궨ΪDWT_CR)λ0ƣд1ʹ
 */


#define  DWT_CR      *(__IO uint32_t *)0xE0001000
#define  DWT_CYCCNT  *(__IO uint32_t *)0xE0001004
#define  DEM_CR      *(__IO uint32_t *)0xE000EDFC


#define  DEM_CR_TRCENA                   (1 << 24)
#define  DWT_CR_CYCCNTENA                (1 <<  0)


/**
  * @brief  ʼʱ
  * @param  
  * @retval 
  * @note   ʹʱǰñ
  */
HAL_StatusTypeDef HAL_InitTick(uint32_t TickPriority)
{
    /* ʹDWT */
    DEM_CR |= (uint32_t)DEM_CR_TRCENA;                

    /* DWT CYCCNTĴ0 */
    DWT_CYCCNT = (uint32_t)0u;

    /* ʹCortex-M DWT CYCCNTĴ */
    DWT_CR |= (uint32_t)DWT_CR_CYCCNTENA;
  
    return HAL_OK;
}

/**
  * @brief  ȡǰʱ
  * @param  
  * @retval ǰʱDWT_CYCCNTĴֵ
  */
uint32_t CPU_TS_TmrRd(void)
{        
  return ((uint32_t)DWT_CYCCNT);
}

/**
  * @brief  ȡǰʱ
  * @param  
  * @retval ǰʱDWT_CYCCNTĴֵ
  */
uint32_t HAL_GetTick(void)
{        
  return ((uint32_t)DWT_CYCCNT/SysClockFreq*1000);
}


/**
  * @brief  CPUڲʵ־ȷʱ32λ
  * @param  us : ӳٳȣλ1 us
  * @retval 
  * @note   ʹñǰȵCPU_TS_TmrInitʹܼ
            ʹܺCPU_TS_INIT_IN_DELAY_FUNCTION
            ʱֵΪ8룬8*1000*1000
  */
void CPU_TS_Tmr_Delay_US(uint32_t us)
{
  uint32_t ticks;
  uint32_t told,tnow,tcnt=0;

  /* ںڲʼʱĴ */  
#if (CPU_TS_INIT_IN_DELAY_FUNCTION)  
  /* ʼʱ */
  HAL_InitTick(5);
#endif
  
  ticks = us * (GET_CPU_ClkFreq() / 1000000);  /* ҪĽ */      
  tcnt = 0;
  told = (uint32_t)CPU_TS_TmrRd();         /* սʱļֵ */

  while(1)
  {
    tnow = (uint32_t)CPU_TS_TmrRd();  
    if(tnow != told)
    { 
        /* 32λǵ */    
      if(tnow > told)
      {
        tcnt += tnow - told;  
      }
      /* װ */
      else 
      {
        tcnt += UINT32_MAX - told + tnow; 
      } 
      
      told = tnow;

      /*ʱ䳬/Ҫӳٵʱ,˳ */
      if(tcnt >= ticks)break;
    }  
  }
}

/*********************************************END OF FILE**********************/
